/*
  Blank Simple Project.c
  http://learn.parallax.com/propeller-c-tutorials 
*/
#include "simpletools.h"                      // Include simple tools
#include "fdserial.h"

volatile char gpsname[6];


struct buffer{
 char NMEA[80]; //gps string buffer
 char gpsraw;  //raw data input from GPS

}buff;

volatile char RMC[100];
volatile char GGA[100];

void getdata2(); //receive data from gps
void parce_rmc();
void print_data(); 
void parce_time();
void print_full();
void init();

void print_GGA();
void print_RMC();
int index;

//HALF DUPLEX SERIAL USED IF USING ANOTHER DEVICE USE fdserial
serial *GPS;  //MASK FOR THE SERIAL INPUT
int rx_pin = 26;
int tx_pin = 20;  
int mode_ = 0;
int Baud_rate = 9600;

int *cog;
int main()                                    // Main function
{
    init();
    cog= cog_run(getdata2,128);
    while(1)
    {
        // getdata();
       // getdata2();
      //  pause(250);//wait for the buffer to fill
       print_RMC();
       // print_GGA();
    } 
}  


void init()
{
#ifndef DEBUG
    GPS = fdserial_open(rx_pin,tx_pin,mode_ ,Baud_rate);
#endif
}


void getdata2()


{

{
    //read in characters from the GPS
    int idx = 0;
    do
    {
        buff.gpsraw = fdserial_rxChar(GPS);
        buff.NMEA[idx++] = buff.gpsraw;   //buffer   
    } while(buff.gpsraw != 13 && buff.gpsraw != 10);
    buff.NMEA[idx] = 0;      //null terminate

    //compare the string to get the RMC sentance

    if(strncmp(buff.NMEA, "$GPRMC", 6) == 0)
         // return buff.NMEA;//return the specific buffer
         
         strcpy(RMC,buff.NMEA);
          strcpy(gpsname,strtok(RMC, ","));
            
    if(strncmp(buff.NMEA, "$GPGGA", 6) == 0)
            strcpy(GGA,buff.NMEA);
    
   //     return buff.NMEA;//return the specific buffer
     // print_GGA();*/
}


}

void print_RMC()


  {
    
  // print("RMC = %s\n", buff.NMEA); 
   print(" %s\n", RMC); 
    print(" %s\n", gpsname);  
  }    
     
void print_GGA()

    { 
     print(" %s\n", GGA); 
   }     